exec("./Support_RaycastingWeapons.cs");
exec("add-ons/vehicle_pirate_cannon/server.cs");


%error = ForceRequiredAddOn("Vehicle_Stunt_Plane");
if(%error == $Error::AddOn_Disabled)
{
   stuntplaneVehicle.uiName = "";
}
else if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Vehicle_Combat_Biplane - required add-on Vehicle_Stunt_Plane not found");
   return;
}

%error = ForceRequiredAddOn("Vehicle_Tank");
if(%error == $Error::AddOn_Disabled)
{
   TankVehicle.uiName = "";
}
else if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Vehicle_Combat_Biplane - required add-on Vehicle_Tank not found");
   return;
}

%error = ForceRequiredAddOn("Weapon_Gun");
if(%error == $Error::AddOn_Disabled)
{
   GunItem.uiName = "";
}
else if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Vehicle_Combat_Biplane - required add-on Weapon_Gun not found");
   return;
}

%error = ForceRequiredAddOn("Weapon_Rocket_Launcher");
if(%error == $Error::AddOn_Disabled)
{
   rocketLauncherItem.uiName = "";
}
else if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Vehicle_Combat_Biplane - required add-on Weapon_Rocket_Launcher not found");
   return;
}

// Explosion Projectile - you can't spawn explosions on the server, so we use a short-lived projectile
/////////////////////////////////
datablock ProjectileData(combatBomberExplosionProjectile : tankshellProjectile)
{
   explosion           = tankShellExplosion;

   directDamageType  = $DamageType::VehicleExplosion;
   radiusDamageType  = $DamageType::VehicleExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 0;

   uiName = "";
};

datablock ExplosionData(combatBomberBombExplosion : tankshellExplosion)
{
   radiusDamage = 10000;
};

datablock ProjectileData(combatBomberBomberProjectile : CannonBallProjectile)
{
   projectileShapeName = "./WARHEAD.dts";
   directDamage        = 200;
   directDamageType = $DamageType::RocketDirect;
   radiusDamageType = $DamageType::RocketRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = combatBomberBombExplosion;
   particleEmitter     = cannonBallTrailEmitter;

   brickExplosionRadius = 5;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 60;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 120;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = WhistleLoopSound;

   muzzleVelocity      = 30;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 10000;
   fadeDelay           = 10000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   explodeOnDeath = 1;

   uiName = "Warhead";
};

datablock WheeledVehicleData(combatBomberVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./ccab1.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 1;
   mountThread[0] = "sit";

	maxDamage = 500.00;
	destroyedLevel = 300.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 9;         // Far distance from vehicle
	cameraOffset = 5.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.2;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	= tankTire;
	defaultSpring	= stuntPlaneSpring;
	flatTire	= stuntPlaneFlatTire;
	flatSpring	= stuntPlaneFlatSpring;

	ShootOnClick=1;

	ShootOnClick_Hold=1;
	ShootOnClick_ShootDelay= 700;
	ShootOnClick_ReShootDelay= 700;
	ShootOnClick_ProjectileCount=1;
	ShootOnClick_RequiredSlot=0;
	ShootOnClick_Sound=rocketFireSound;

	ShootOnClick_Projectile[0]= rocketProjectile;
	ShootOnClick_Position[0]="-1 0.8 0.6";
	ShootOnClick_Scale[0]="2 9 2";
	ShootOnClick_Velocity[0]="1000 0 0";

   numWheels = 3;

	// Rigid Body
	mass = 230;
	density = 5.0;
	drag = 0.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 2000; //4000;       // Engine power
	engineBrake = 1000;         // Braking when throttle is 0
	brakeTorque = 5000;        // When brakes are applied
	maxWheelSpeed = 50;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 1800;
	reverseThrust		= 1400;
	lift			= 110;
	maxForwardVel		= 50;
	maxReverseVel		= 50;
	horizontalSurfaceForce	= 130;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 130; 
	rollForce		= 8500;
	yawForce		= 6500;
	pitchForce		= 6500;
	rotationalDrag		= 0.5;
	stallSpeed		= 30;
   burnTime = 0;

//   forwardThrust		= 2000;
//	reverseThrust		= 2000;
//	lift			= 100;
//	maxForwardVel		= 70;
//	maxReverseVel		= 70;
//	horizontalSurfaceForce	= 100;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
//	verticalSurfaceForce	= 100; 
//	rollForce		= 6000;
//	yawForce		= 6000;
//	pitchForce		= 4000;
//	rotationalDrag		= 0.5;
//	stallSpeed		= 10;
//
//   forwardThrust		= 2500;
//	reverseThrust		= 500;
//	lift			= 15000;
//	maxForwardVel		= 60;
//	maxReverseVel		= 10;
//	horizontalSurfaceForce	= 500;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
//	verticalSurfaceForce	= 500; 
//	rollForce		= 5000;
//	yawForce		= 5000;
//	pitchForce		= 5000;
//	rotationalDrag		= 0.1;
//	stallSpeed		= 10;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = engineidleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Combat Bomber ";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

//   initialExplosionProjectile = combatBomberExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 0;

   finalExplosionProjectile = combatBomberExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
   
   // Advanced Steering
   steeringAutoReturn = false;
   // steeringAutoReturnRate = 0.9;
   // steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = false;
   // steeringStrafeSteeringRate = 0.1;

	minSoispeed = 24;
	minExplosionspeed = 12;
};

datablock ShapeBaseImageData(combatBomberLauncherImage : rocketLauncherImage)
{
   shapeFile = "base/data/shapes/empty.dts";

   mountPoint = 2;
};

datablock ShapeBaseImageData(combatBomberMissileImage : rocketLauncherImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   projectile = combatBomberBomberProjectile;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
   stateTransitionOnNoAmmo[1]       = "NoAmmo";
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= rocketLauncherFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= tailNode;
	stateSound[2]					= rocketFireSound;
   stateSequence[2]                = "Fire";
	//stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= rocketLauncherSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.1;
   stateSequence[3]                = "TrigDown";
	stateTransitionOnTimeout[3]     = "CoolDown";

   stateName[5] = "CoolDown";
   stateTimeoutValue[5]            = 2.5;
	stateTransitionOnTimeout[5]     = "Reload";
   stateSequence[5]                = "TrigDown";


	stateName[4]			= "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "TrigDown";

   stateName[6]   = "NoAmmo";
   stateTransitionOnAmmo[6] = "Ready";

   mountPoint = 3;
};

function combatBomberVehicle::onAdd(%this, %obj)
{ 	
   Parent::onAdd(%this, %obj);

   %obj.mountImage(combatBomberMissileImage, 3);
   %obj.mountImage(combatBomberLauncherImage, 1);

   %obj.prop = "off";
   soiCheck(%obj);
}

function soiCheck(%obj)
{
   if(!isObject(%obj))
      return;

   %speed = vectorLen(%obj.getVelocity());

   if(%speed < 1 && %obj.getMountedObject(0) == 0)
   {
      if(%obj.prop !$= "off")
      {
         %obj.stopThread(0);
         %obj.playAudio(0, combatBomberEngineOffSound);
         %obj.prop = "off";
      }
   }
   else if(%speed < 29)
   {
      if(%obj.prop !$= "slow")
      {
         %obj.playThread(0, prop_slow);
         %obj.playAudio(0, combatBomberIdleSound);
         %obj.prop = "slow";
      }
   }
   else 
   {
      if(%obj.prop !$= "fast")
      {
         %obj.playThread(0, prop_fast);
         %obj.playAudio(0, combatBomberFlySound);
         %obj.prop = "fast";
      }
   }

   schedule(1000, 0, "soiCheck", %obj);
}

function combatBomberVehicle::onTrigger(%this, %obj, %triggerNum, %val)
{ 	
   if(%triggerNum == 2)
      %obj.setImageTrigger(3, %val);
}

function WheeledVehicle::isFirstPerson(%this, %obj)
{
   return false;
}

function combatBomberVehicle::onImpact(%this, %obj, %data)
{
   %speed = vectorLen(%obj.getVelocity());
   if(%speed < %obj.dataBlock.minExplosionSpeed)
      return;

   %p = new Projectile()
   {
      dataBlock = combatBomberExplosionProjectile;
      initialPosition = %obj.getPosition();
      client = %obj.lastDamageClient;
      sourceClient = %obj.lastDamageClient;
   };
   MissionCleanup.add(%p);

   if(%obj.destroyed)
      return;

   %obj.setDamageLevel(%this.maxDamage);
   %obj.destroyed = 1;
   %obj.schedule(%this.burnTime, "finalExplosion");
   if(isObject(%obj.spawnBrick.client.minigame))
      %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
   %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
}

function combatBomberVehicle::onDriverLeave(%this, %obj)
{
   %obj.client = "";
   Parent::onDriverLeave(%this, %obj);
}

package soi3Package
{
   function Armor::onMount(%this,%obj,%col,%slot)
   {
      Parent::onMount(%this, %obj, %col, %slot);

      if(%col.getDataBlock() == combatBomberVehicle.getId())
      {
         %col.client = %obj.client;

         %speed = vectorLen(%col.getVelocity());
         if(%speed < 1)
            %col.playAudio(0, combatBomberEngineOnSound);
      }
   }

   function Armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
      %mount = %obj.getObjectMount();
      if(isObject(%mount) && %mount.getDatablock() == combatBomberVehicle.getID() && %triggerNum == 0)
      {
         %mount.setImageTrigger(1, %val);
      }

      Parent::onTrigger(%this, %obj, %triggerNum, %val);
   }
};
activatePackage(soi3Package);
